"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Selectbox = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const Pointer_1 = require("@procyon/components/Icons/Pointer");
const hooks_1 = require("@procyon/components/Modal/hooks");
const TextField_1 = require("../../TextField");
const SelectboxModal_1 = require("./SelectboxModal");
const Selectbox = (props) => {
    const { value, options, onChange, name, label, autoComplete } = props, others = __rest(props, ["value", "options", "onChange", "name", "label", "autoComplete"]);
    const { openModal, closeModal, registerModal } = (0, hooks_1.useModal)();
    const [selectedOption, setSelectedOption] = (0, react_1.useState)(null);
    (0, react_1.useEffect)(() => {
        if (value && options) {
            const newValue = (0, ramda_1.find)((0, ramda_1.propEq)('code', value), options);
            setSelectedOption(newValue);
        }
    }, [value, options]);
    const handleOptionClick = (option) => {
        setSelectedOption(option);
        onChange === null || onChange === void 0 ? void 0 : onChange(option, null);
    };
    const handleOptionRemove = () => {
        setSelectedOption(null);
        onChange === null || onChange === void 0 ? void 0 : onChange(undefined, null);
    };
    const handleCloseModal = (id) => {
        closeModal(id);
    };
    const modalComponent = (0, react_1.useCallback)((props) => (react_1.default.createElement(SelectboxModal_1.SelectboxModal, Object.assign({ autoComplete: autoComplete, name: name, options: options, selectedOption: selectedOption, closeModal: handleCloseModal, onChange: handleOptionClick, onRemove: handleOptionRemove }, props))), [autoComplete, name, options, selectedOption]);
    const handleOpenModal = () => {
        registerModal({
            id: name,
            title: label,
            style: { width: 300 },
            Component: modalComponent,
        });
        openModal(name);
    };
    return (react_1.default.createElement(TextField_1.TextField, Object.assign({}, others, { name: name, label: label, value: (0, ramda_1.propOr)('', 'name', selectedOption), readonly: true, leftIcon: react_1.default.createElement(Pointer_1.PointerIcon, { className: "cursor-pointer text-primary-200", onClick: handleOpenModal }) })));
};
exports.Selectbox = Selectbox;
