"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextField = void 0;
const react_1 = __importStar(require("react"));
const clsx_1 = __importDefault(require("clsx"));
const common_1 = require("@procyon/types/common");
const utils_1 = require("@procyon/utils");
const TextField = (props) => {
    const { type = 'text', onClick, onFocus, onBlur, onChange, disabled, name, label, readonly, status, autoFocus, mask, placeholder, multiline, leftIcon, rightIcon, } = props;
    const [value, setValue] = (0, react_1.useState)(undefined);
    const applyMask = (val) => {
        if (mask && val) {
            return utils_1.masker.toPattern(val.toString(), mask);
        }
        return val;
    };
    (0, react_1.useEffect)(() => {
        if (props.value !== undefined) {
            setValue(applyMask(props.value));
        }
    }, [props.value]);
    const handleClick = (0, react_1.useCallback)((e) => {
        if (onClick) {
            onClick(e.currentTarget.value, e);
        }
    }, [onClick]);
    const handleFocus = (0, react_1.useCallback)((e) => {
        if (onFocus) {
            onFocus(e.currentTarget.value, e);
        }
    }, [onFocus]);
    const handleBlur = (0, react_1.useCallback)((e) => {
        if (onBlur) {
            onBlur(e.currentTarget.value, e);
        }
    }, [onBlur]);
    const handleChange = (e) => {
        const val = e.currentTarget.value;
        if (!disabled) {
            setValue(applyMask(val));
            if (onChange) {
                onChange(applyMask(val), e);
            }
        }
    };
    const calculateHeight = (e) => {
        var _a;
        const count = ((_a = e.value.match(/\n/g)) !== null && _a !== void 0 ? _a : []).length + 1;
        const height = parseInt(window.getComputedStyle(e).lineHeight);
        if (count === 1) {
            e.style.height = '';
        }
        else {
            e.style.height = `${height * count + height / 2}px`;
        }
    };
    const passProps = {
        id: name,
        className: (0, clsx_1.default)('field-input masked', {
            'field-input--nolabel': !label,
            'field-input--multiline': multiline,
        }),
        disabled: disabled,
        readOnly: readonly,
        value: value !== null && value !== void 0 ? value : '',
        onClick: handleClick,
        onFocus: handleFocus,
        onBlur: handleBlur,
        onChange: handleChange,
        autoFocus: autoFocus,
        name: name,
    };
    return (react_1.default.createElement("div", { className: (0, clsx_1.default)('field-container', {
            'field-container--multiline': multiline,
            'field-container--info': status === common_1.StatusEnum.info,
            'field-container--success': status === common_1.StatusEnum.success,
            'field-container--warning': status === common_1.StatusEnum.warning,
            'field-container--error': status === common_1.StatusEnum.error,
        }) },
        label && (react_1.default.createElement("label", { htmlFor: name, className: (0, clsx_1.default)('field-label', {
                'field-label--disabled': disabled,
            }) }, label)),
        leftIcon && react_1.default.createElement("div", { className: "mr-2 self-center text-base" }, leftIcon),
        multiline ? (react_1.default.createElement("textarea", Object.assign({}, passProps, { ref: (ref) => ref && calculateHeight(ref) }))) : (react_1.default.createElement("input", Object.assign({}, passProps, { className: (0, clsx_1.default)(passProps.className, {
                'field-input--nolabel': !label,
            }), placeholder: placeholder, autoComplete: "off", type: type }))),
        rightIcon && react_1.default.createElement("div", { className: "ml-2 self-center" }, rightIcon)));
};
exports.TextField = TextField;
